/* Prodotto di due matrici inserite da tastiera */

#include <stdio.h>

/* Dimensioni delle matrici */
#define MDIM 3
#define PDIM 4
#define NDIM 2

void prod_matr(double A[][PDIM], double B[][NDIM], double C[][NDIM]);
/* in alternativa: 
   void prod_matr(double A[MDIM][PDIM], double B[PDIM][NDIM], double C[MDIM][NDIM]); */

int main(void) {

  double matA[MDIM][PDIM], matB[PDIM][NDIM], matC[MDIM][NDIM]; 
  int i, j;

  /* Lettura matrici */
  printf("Lettura prima matrice %dX%d:\n", MDIM, PDIM);
  for (i = 0; i < MDIM; i++)
    for (j = 0; j < PDIM; j++)
      scanf("%lf", &matA[i][j]);
  printf("Lettura seconda matrice %dX%d:\n", PDIM, NDIM);
  for (i = 0; i < PDIM; i++)
    for (j = 0; j < NDIM; j++)
      scanf("%lf", &matB[i][j]);

  /* Prodotto tra matrici matA = matB*matC */
  prod_matr(matA, matB, matC);
    
  /* Stampa per righe della matrice risultante */
  printf("Matrice prodotto:\n");
  for (i = 0; i < MDIM; i++) {
    for (j = 0; j < NDIM; j++)
      printf("%4.2lf ", matC[i][j]);
    printf("\n");
  }

  return 0;

}

/* in alternativa: 
   void prod_matr(double A[MDIM][PDIM], double B[PDIM][NDIM], double C[MDIM][NDIM]) */
void prod_matr(double A[][PDIM], double B[][NDIM], double C[][NDIM])
{
  int i, j, k;

  /* Calcolo prodotto */
  for (i = 0; i < MDIM; i++) /* ciclo su righe */
    for (j = 0; j < NDIM; j++) {
      C[i][j] = 0;
      for (k = 0; k < PDIM; k++)
        C[i][j] = C[i][j] + A[i][k] * B[k][j];
    }
  return;
}